'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const meta = require('./meta.js');

const skeletons = /* @__PURE__ */ new WeakSet();
const isSkeleton = (object) => {
  var _a;
  return skeletons.has(object) || skeletons.has((_a = meta.$meta(object)) == null ? void 0 : _a.cache.data);
};
const createSkeleton = (fn) => {
  const skeleton = fn();
  skeletons.add(skeleton);
  return skeleton;
};

exports.createSkeleton = createSkeleton;
exports.isSkeleton = isSkeleton;
