import { $meta } from './meta.mjs';

const skeletons = /* @__PURE__ */ new WeakSet();
const isSkeleton = (object) => {
  var _a;
  return skeletons.has(object) || skeletons.has((_a = $meta(object)) == null ? void 0 : _a.cache.data);
};
const createSkeleton = (fn) => {
  const skeleton = fn();
  skeletons.add(skeleton);
  return skeleton;
};

export { createSkeleton, isSkeleton };
