'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const createLegacyPrefetch = ({
  resolvers: { createResolver },
  subscribeLegacySelections
}) => (fn, { operationName } = {}) => {
  const {
    accessor: { query },
    context,
    resolve
  } = createResolver({ operationName });
  const unsubscribe = subscribeLegacySelections((selection, cache) => {
    var _a;
    (_a = context.onSelect) == null ? void 0 : _a.call(context, selection, cache);
  });
  const data = fn(query);
  unsubscribe();
  if (!context.shouldFetch) {
    return data;
  }
  return resolve().then(() => fn(query));
};

exports.createLegacyPrefetch = createLegacyPrefetch;
