'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('../Cache/index.js');

const createContext = ({
  cache,
  cachePolicy,
  depthLimit,
  onSelect,
  scalars,
  schema,
  typeKeys
}) => ({
  cache: cachePolicy === "no-cache" || cachePolicy === "no-store" || cachePolicy === "reload" ? new index.Cache(void 0, { maxAge: 0, normalization: false }) : cache,
  cacheOptions: {
    includeExpired: cachePolicy === "default" || cachePolicy === "force-cache" || cachePolicy === "only-if-cached"
  },
  scalars,
  schema,
  depthLimit,
  hasCacheHit: false,
  hasCacheMiss: false,
  shouldFetch: false,
  notifyCacheUpdate: cachePolicy !== "default",
  onSelect(selection, cacheNode) {
    const now = Date.now();
    const { data, expiresAt: age = Infinity } = cacheNode != null ? cacheNode : {};
    this.shouldFetch || (this.shouldFetch = data === void 0 || age < now - 100);
    this.hasCacheHit || (this.hasCacheHit = data !== void 0);
    this.notifyCacheUpdate || (this.notifyCacheUpdate = data === void 0);
    onSelect == null ? void 0 : onSelect(selection, cacheNode);
  },
  typeKeys
});

exports.createContext = createContext;
