import type { Cache } from '../Cache';
import type { QueryPayload } from '../Schema';
import type { Selection } from '../Selection';
import type { FetchResult, QueryExtensions } from './resolveSelections';
export type DebugEvent = {
    cache?: Cache;
    label?: string;
    request: QueryPayload<QueryExtensions>;
    result?: FetchResult;
    selections: Set<Selection>;
};
export type DebugEventListener = (event: DebugEvent) => void;
export type Debugger = {
    dispatch: (event: DebugEvent) => void;
    /** Returns an unsubscribe function */
    subscribe: (listener: DebugEventListener) => () => void;
};
export declare const createDebugger: () => {
    dispatch: (event: DebugEvent) => void;
    subscribe: (listener: DebugEventListener) => () => boolean;
};
