'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const createDebugger = () => {
  const subs = /* @__PURE__ */ new Set();
  return {
    dispatch: (event) => {
      subs.forEach((sub) => sub(event));
    },
    subscribe: (listener) => {
      subs.add(listener);
      return () => subs.delete(listener);
    }
  };
};

exports.createDebugger = createDebugger;
