import type { Cache } from '../Cache';
import type { QueryPayload } from '../Schema';
import type { Selection } from '../Selection';
export type QueryBuilderOptions = {
    batchWindow: number;
    batchStrategy: 'debounce' | 'throttle';
    cache: Cache;
};
export type BuiltQuery = QueryPayload<{
    type: 'query' | 'mutation' | 'subscription';
    hash: string;
}>;
export declare const buildQuery: (selections: Set<Selection>, operationName?: string) => BuiltQuery[];
