export type SelectionOptions = {
    readonly alias?: string;
    readonly aliasLength?: number;
    readonly input?: SelectionInput;
    readonly isUnion?: boolean;
    readonly parent?: Selection;
};
export type SelectionInput = {
    readonly types: Record<string, string>;
    readonly values: Record<string, unknown>;
};
export type SelectionSnapshot = Array<[
    string | number,
    SelectionOptions
] | [string | number]>;
export declare class Selection {
    readonly key: string | number;
    readonly alias?: string;
    readonly cacheKeys: string[];
    readonly children: Map<string | number, Selection>;
    readonly input?: SelectionInput;
    readonly parent?: Selection;
    readonly root: Selection;
    /** Indicates current selection being a inteface/union key. */
    readonly isUnion: boolean;
    constructor(key: string | number, { input, alias, isUnion, parent }?: SelectionOptions, token?: symbol);
    /** The selection path from root the leaf as an array. */
    get ancestry(): Selection[];
    static createRoot(key: string): Selection;
    getChild(key: string | number, options?: SelectionOptions): Selection;
    getLeafNodes(this: Selection): Set<Selection>;
    toJSON(): SelectionSnapshot;
    fromJSON(this: Selection, json: SelectionSnapshot): Selection;
}
