'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const set = require('just-safe-set');

function _interopDefault (e) { return e && e.__esModule ? e : { 'default': e }; }

const set__default = /*#__PURE__*/_interopDefault(set);

const pick = (schema, selections) => {
  const result = {};
  for (const { ancestry } of selections) {
    let node = schema;
    for (const { key, input } of ancestry) {
      if (input) {
        node = node[key](input.values);
      } else {
        node = node[key];
      }
    }
    if (node !== void 0) {
      set__default["default"](result, ancestry.map((s) => {
        var _a;
        return (_a = s.alias) != null ? _a : s.key;
      }).join("."), node);
    }
  }
  return result;
};

exports.pick = pick;
