import set from 'just-safe-set';

const pick = (schema, selections) => {
  const result = {};
  for (const { ancestry } of selections) {
    let node = schema;
    for (const { key, input } of ancestry) {
      if (input) {
        node = node[key](input.values);
      } else {
        node = node[key];
      }
    }
    if (node !== void 0) {
      set(result, ancestry.map((s) => {
        var _a;
        return (_a = s.alias) != null ? _a : s.key;
      }).join("."), node);
    }
  }
  return result;
};

export { pick };
